using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.Windows.Forms;
using System.Text;
using System.Globalization;
using Infragistics.Win;
using Infragistics.Win.UltraWinSchedule;
using Infragistics.Win.UltraWinSchedule.DayView;
using System.Linq;
using objDayView = Infragistics.Win.UltraWinSchedule.DayView;
using objAppt = Infragistics.Win.UltraWinSchedule.Appointment;

namespace MyTest.TestProject
{
    using Infragistics.Win.UltraWinSchedule.TimelineView;

    public class MyCreationFilter : IUIElementCreationFilter, IDisposable
    {
        public delegate void OnDayHeaderCheckEvent(object sender, DayHeaderCheckBoxArg e);
        public event OnDayHeaderCheckEvent DayHeaderCheck;
        List<Bitmap> mImages = ESImageUtil.GetTheESImages();
        LocationDefault mLocDefault;
        private ESDictionary mDictWaitlistReason = ConfigurationCache.DictionaryCache.GetDictionary(ESDictionary.DictionaryTypes.WaitlistReason);
        private ESDictionary mDictCancelReason = ConfigurationCache.DictionaryCache.GetDictionary(ESDictionary.DictionaryTypes.CancelReason);
        private ESDictionary mDictReschedReason = ConfigurationCache.DictionaryCache.GetDictionary(ESDictionary.DictionaryTypes.ReschduleReason);
        private MyTestAppointmentCollection mMyTestAppointments = new MyTestAppointmentCollection();
        private List<OwnerAppointments> _ownerAppointmentsesCollection;

        /// <summary>
        /// Gets or sets appointments Collection for a single owner
        /// </summary>
        public List<OwnerAppointments> OwnerAppointmentsesCollection
        {
            get
            {
                return _ownerAppointmentsesCollection ?? (_ownerAppointmentsesCollection = new List<OwnerAppointments>());
            }

            set
            {
                _ownerAppointmentsesCollection = value;
            }
        }

        #endregion

        bool IUIElementCreationFilter.BeforeCreateChildElements(Infragistics.Win.UIElement parent)
        {
            return false;
        }
            int count = 0;

            foreach (var displayapp in OwnerAppointmentsesCollection)
            {
                count++;
                foreach (var app in OwnerAppointmentsesCollection)
                {
                    if (app.State == 0)
                    {
                        if ((displayapp.Appt.Start >= app.Appt.Start &&
                            displayapp.Appt.Start <= app.Appt.End)
                            ||
                            (displayapp.Appt.End >= app.Appt.Start &&
                            displayapp.Appt.End <= app.Appt.End))
                        {
                            app.State = count;
                        }
                    }
                }
            }

            for (int i = 1; i <= count; i++)
            {
                int y = 0;
                int j = 0;

                int items = OwnerAppointmentsesCollection.Where(s => s.State == i).Count();
                if (items > 0)
                {
                    foreach (var app in OwnerAppointmentsesCollection)
                    {
                        if (app.State == i)
                        {
                            int height = slotHeight / items;
                            if (j == 0)
                            {
                                y = app.Appt.Rect.Y;
                            }

                            app.Appt.Rect = new Rectangle(app.Appt.Rect.X, y, app.Appt.Rect.Width, height);
                            j++;
                            y += height;
                        }
                    }
                }
            }
        }

        void IUIElementCreationFilter.AfterCreateChildElements(Infragistics.Win.UIElement parent)
        {
            if (parent is objDayView.OwnerHeaderUIElement)
            {
                if (parent.Parent?.ChildElements?.Count != 0)
                {
                    var ownerHeader = (objDayView.OwnerHeaderUIElement)parent;
                    var day = parent.Parent.ChildElements[0] as DayHeaderUIElement;

                    if (day == null)
                    {
                        return;
                    }

                    if (!OwnerStateList.ContainsKey(ownerHeader.Owner.Name))
                    {
                        OwnerStateList.Add(ownerHeader.Owner.Name, new Dictionary<DateTime, OwnerState>());
                    }

                    if (!OwnerStateList[ownerHeader.Owner.Name].ContainsKey(day.Date))
                    {

                        OwnerStateList[ownerHeader.Owner.Name].Add(day.Date, new OwnerState(false));

                    }

                    if (ownerHeader.ChildElements.Count == 1)
                    {
                        CreateCheckBox(ownerHeader, day);

                        CreateIcon(ownerHeader);
                        ((TextUIElement)ownerHeader.ChildElements[0]).TextHAlign = HAlign.Center;
                    }
                }
            }

            var count = 0;

            if (parent is ActivityAreaUIElement)
            {
                count = 0;
                var ownerapp = new List<OwnerAppointments>();
                foreach (var appt in parent.ChildElements.OfType<AppointmentUIElement>())
                {
                    count++;

                    ownerapp.Add(new OwnerAppointments { State = 0, Appt = appt });
                }

                OwnerAppointmentsesCollection = ownerapp;
                GetCrossingAppointments(parent.Rect.Height);
            }

            // Day View Appointments
            if (parent is TextUIElement && parent.GetAncestor(typeof(objDayView.AppointmentUIElement)) != null)
            {
                var appointmentElement =
                    parent.GetAncestor(typeof(objDayView.AppointmentUIElement)) as objDayView.AppointmentUIElement;
                var appointment = appointmentElement?.GetContext(typeof(objAppt)) as objAppt;

                var textElement = appointmentElement.GetDescendant(typeof(TextUIElement)) as TextUIElement;
                if (textElement != null && appointment != null)
                {
                    textElement.Text = appointment.Subject;
                }
            }
			
            if (parent is objDayView.AppointmentUIElement || parent is AppointmentUIElement || parent is infMonthView.DayUIElement)
            {
                var appt = parent.GetContext(typeof(Infragistics.Win.UltraWinSchedule.Appointment)) as MyAppointment;
                if (appt == null)
                {
                    return;
                }

                var myAppt = appt.DataKey as MyTestAppointment;

                appt.Subject = CreateAppointmentSubject(myAppt);
                appt.TheToolTipText = CreateAppointmentToolTip(myAppt);
                
                Bitmap[] bmps = GetBitmapsForAppointment(myAppt);

                if (bmps == null || bmps.Length == 0) return;

                bool isHoriz;
                int xLoc;
                int yLoc;
                int width;
                int height;

                InitVariables(out width, out height, out xLoc, out yLoc, out isHoriz, parent, bmps);

                foreach (var imgElem in
                    bmps.Select(
                        bmp => new ImageUIElement(parent, bmp) { Rect = new Rectangle(xLoc, yLoc, width, height) }))
                {
                    parent.ChildElements.Add(imgElem);

                    if (isHoriz)
                    {
                        xLoc += width;
                    }
                    else
                    {
                        yLoc += height;
                    }
                }

                int totalWidth;

                if (isHoriz)
                {
                    totalWidth = width * bmps.Length;
                }
                else
                {
                    totalWidth = width;
                }

                var txtElem = parent.GetDescendant(typeof(EditorWithTextUIElement)) as EditorWithTextUIElement;

                if (txtElem != null)
                {
                    txtElem.Rect = new Rectangle(
                        txtElem.Rect.Left + totalWidth,
                        txtElem.Rect.Top,
                        txtElem.Rect.Width - totalWidth,
                        txtElem.Rect.Height);
                }
            }
        }

        private void CheckBoxElementClick(object sender, UIElementEventArgs e)
        {
            if (e.Element == null)
            {
                return;
            }

            var checkBoxUi = e.Element as CheckBoxUIElement;
            if (checkBoxUi != null && !checkBoxUi.Enabled)
            {
                return;
            }

            var owner = checkBoxUi?.Parent as objDayView.OwnerHeaderUIElement;
            var day = checkBoxUi?.Parent?.Parent?.ChildElements[0] as DayHeaderUIElement;

            if (owner == null || day == null)
            {
                return;
            }

            checkBoxUi.ElementClick -= CheckBoxElementClick;
            checkBoxUi.CheckState = OwnerStateList[owner.Owner.Name][day.Date].CheckAllApptStatus
                                        ? CheckState.Unchecked
                                        : CheckState.Checked;
            checkBoxUi.ElementClick += CheckBoxElementClick;
            OwnerStateList[owner.Owner.Name][day.Date].CheckAllApptStatus = !OwnerStateList[owner.Owner.Name][day.Date].CheckAllApptStatus;

            DayHeaderCheck?.Invoke(checkBoxUi, new DayHeaderCheckBoxArg(owner.Owner, day.Date));
        }

        private void CreateIcon(objDayView.OwnerHeaderUIElement ownerHeader)
        {

            var lockIconImage = new ImageUIElement(ownerHeader, GetImages())
            {
                Rect = ownerHeader.Rect
            };
            
            lockIconImage.Rect = new Rectangle(ownerHeader.ChildElements[1].Rect.X + 15,ownerHeader.ChildElements[0].Rect.Y + 2, 15, 15);
            lockIconImage.ToolTipItem = _toolTipItem;
            ownerHeader.ChildElements.Add(lockIconImage);

            // Re-align the header textUI element w.r.t the checkbox and lock icon.
            ownerHeader.ChildElements[0].Rect = new Rectangle(
                (ownerHeader.ChildElements[0].Rect.Left <= ownerHeader.ChildElements[2].Rect.Right)
                    ? ownerHeader.ChildElements[2].Rect.Right + 10 : ownerHeader.ChildElements[0].Rect.Left,
                ownerHeader.ChildElements[0].Rect.Y,
                ownerHeader.ChildElements[0].Rect.Width,
                ownerHeader.ChildElements[0].Rect.Height);
        }

        private void CreateCheckBox(objDayView.OwnerHeaderUIElement ownerHeader, DayHeaderUIElement day)
        {
            var checkComplete = new CheckBoxUIElement(ownerHeader)
            {
                Rect = ownerHeader.Rect
            };

            checkComplete.Rect = new Rectangle(ownerHeader.Rect.Left + 10, ownerHeader.ChildElements[0].Rect.Y + 2, 14, 14);

            checkComplete.CheckState = OwnerStateList[ownerHeader.Owner.Name][day.Date].CheckAllApptStatus
                                           ? CheckState.Checked
                                           : CheckState.Unchecked;

            checkComplete.Enabled = OwnerStateList[ownerHeader.Owner.Name][day.Date].IsOwnerCheckAccessible;
            checkComplete.ElementClick += CheckBoxElementClick;
            checkComplete.ToolTipItem = _toolTipItem;
            checkComplete.CheckAlign = ContentAlignment.MiddleLeft;
            ownerHeader.ChildElements.Add(checkComplete);
        }
    }
}
